DROP TRIGGER IF EXISTS tDataInsert_updated;

CREATE TRIGGER IF NOT EXISTS tDataInsert_updated AFTER INSERT ON data BEGIN UPDATE data SET updated = DATETIME('NOW') WHERE rowid = new.rowid AND new.updated IS null;

  DELETE FROM data WHERE
	data.sourceFieldId = new.sourceFieldId
    AND	data.dataKeyId = new.dataKeyId
    AND (data.value = new.value OR (data.value IS NULL AND new.value IS NULL))
    AND (SELECT vField.history FROM vField WHERE vField.sourceFieldId = data.sourceFieldId) = 1
    AND data.id = (
	  SELECT
	    d2.id
	  FROM
	    data AS d2
	  WHERE
		d2.sourceFieldId = new.sourceFieldId
	    AND	d2.dataKeyId = new.dataKeyId
	  ORDER BY
	    d2.updated DESC
	  LIMIT 1,1
    );

  DELETE FROM
    data
  WHERE
      data.id != new.id
      AND (
	  SELECT
	    vField.history
	  FROM
	    vField
	  WHERE	    
	    vField.sourceFieldId = new.sourceFieldId
	) = 0
    AND data.sourceFieldId = new.sourceFieldId
    AND data.dataKeyId = new.dataKeyId;

END;